/*
 * UART1_IRQ.h
 *
 * Created: 27.3.2015 12:28:35
 *  Author: maticpi
 */ 


#ifndef UART1_IRQ_H_
#define UART1_IRQ_H_

#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h>
#include <util/atomic.h>
#include "config.h"

//Set your own names of the functions for each UART
/*
#define _Init() UART1_Init()
#define _SendStr(x) UART1_SendStr(x)
#define _SendBytes(x,y) UART1_SendBytes(x,y)
#define _putc(x,y) UART1_putc(x,y)
#define _DataReady() UART1_DataReady()
#define _GetByte() UART1_GetByte()
#define _put(x) UART1_put(x)
#define _numTxBytes() UART1_numTxBytes()	//not much point
#define _numRxBytes() UART1_numRxBytes()
#define _PreviewRxByte(x) UART1_PreviewRxByte(x)
#define _str UART1_str
*/

void UART1_Init();
char UART1_SendStr(char str[]);
char UART1_SendBytes(char data[], int num);
int UART1_putc(char c, FILE *stream);
int UART1_DataReady();
char UART1_GetByte();
char UART1_put(char data);
char UART1_getTxByteFromBuffer();
int UART1_numTxBytes();
int UART1_numRxBytes();
char UART1_PreviewRxByte(int index);

extern FILE UART1_str;

#define TB_SIZE1	100
extern volatile char TxBuf1[TB_SIZE1];
extern int TBin1;
extern volatile int TBout1;
extern volatile int TBnum1;

#define RB_SIZE1	100
extern volatile char RxBuf1[RB_SIZE1];
extern int RBin1;
extern volatile int RBout1;
extern volatile int RBnum1;

#endif /* UART1_IRQ_H_ */