/*
 * FW_UV_driver.c
 *
 * Created: 12-Jul-16 14:30:46
 * Author : maticpi
 */ 

#include "main.h"

uint16_t Err1LOD,Err2LOD;
uint8_t ErrSignal_TEF;
uint8_t mode;
int32_t timer;
float dose;
float K=1;

int main(void)
{
	uint32_t timeReport=0;
	uint8_t cmd;
	int i,h,m,s;

	Init_IO();
	InitTemperature();
	systime_init();
	TLC59401_Init();
	InitUsageCounters();
	UART0_Init();
	stdout = &UART0_str;
	sei();
	//DEBUG - delete this
/*	PORTB=0;
	DDRB=0xff;
	PORTD|=0x0F<<2;
	DDRD&=~(0x0F<<2);
	while (1)
	{
		if (UART0_DataReady())
		{
			cmd=UART0_GetByte();
			switch (cmd)
			{
				case '1': //+1 min v EEPROM
					SaveBackupUsageData();
					PrintEEPROMusgData();
					break;
				case '2':
					StoreUsageData(1);
					PrintEEPROMusgData();
					break;
				case '3':
					InitUsageCounters();
					PrintEEPROMusgData();
					break;
				case '4':
					UpdateUsage(); //to funkcijo klice main, preverja ce je ze 1s minila
					PrintEEPROMusgData();
					break;
				case '5':
					CheckBackupUsageData();
					PrintEEPROMusgData();
					break;
				case '6':
					InvalidateBackedupUsageData();
					PrintEEPROMusgData();
					break;
				case '7':
					for (i=0;i<30;i++) SaveBackupUsageData();
					PrintEEPROMusgData();
					break;
				case 'E':
					EraseUsageEEPROM();
					PrintEEPROMusgData();
					break;
				case 'p':
				case 13:
					PrintEEPROMusgData();
					break;
				case 'b':
				case ' ':
					PrintEEPROMusgData();
					PORTB^=0x01;
					break;
				default: break;
			}
		}
	}*/
	//DEBUG - delete to here

    while (1) 
    {
		if (UART0_DataReady())
		{
			cmd=UART0_GetByte();
			switch (cmd)
			{
				case ' ':
				case '?':
				case 'h':
					printf_P(PSTR("Debug features:\n"));
					printf_P(PSTR("c - pulse GSCLK\n"));
					printf_P(PSTR("d - set DC(10%%)\n"));
					printf_P(PSTR("g - set GS\n"));
					printf_P(PSTR("i - get info\n"));
					printf_P(PSTR("E - get all EEPROM data\n"));
					printf_P(PSTR("l - lock-in (PWM)\n"));
					printf_P(PSTR("p - get PORTB and PORTD status\n"));
					printf_P(PSTR("e - check for errors\n"));
					printf_P(PSTR("t - report temperatures\n"));
					printf_P(PSTR("u - get usage data\n"));
					printf_P(PSTR("Runtime commands:\n"));
					printf_P(PSTR("0 - Off (BLANK high)\n"));
					printf_P(PSTR("1 - On (Set DC 10%%, BLANK low)\n"));
					printf_P(PSTR("2 - On (Set DC 30%%, BLANK low)\n"));
					printf_P(PSTR("3 - On (Set DC 100%%, BLANK low)\n"));
					printf_P(PSTR("T - Set Count-down timer(in seconds).\n"));
					printf_P(PSTR("D - Set dose(in J/m2).\n"));
					printf_P(PSTR("L - set DC data for 10%% level\n"));
					printf_P(PSTR("M - set DC data for 30%% level\n"));
					printf_P(PSTR("H - set DC data for 100%% level\n"));
					printf_P(PSTR("C - set Calibration data.\n"));
					printf_P(PSTR("K - set Correction factor.\n"));
					printf_P(PSTR("s - save data to EEPROM\n"));
					break;
				case 'R': //Reset usage data - do not document anywhere - this should not be possible
					ValidateCommandAndResetUsageCounter();
					break;
				case 'c':	//for debug only
					printf_P(PSTR("Pulsing GSCLK\n"));
					GSClkPulse();
					break;
				case 'd':	//set DC10% - for debug only
					printf_P(PSTR("set DC(10%%)\n"));
					SetDC(DCdata10);
					break;
				case 'g':	//set GS - for debug only
					printf_P(PSTR("set GS\n"));
					SetGSandGetStatus(GSdata,status);
					break;
				case 'l':	//lock-in: enable/disable PWM mode
					if (!PWM) EnableLockIn();
					else DisableLockIn();
					break;
				case 'i':	//info - for debug only
					printf_P(PSTR("1: LOD:0x%02x%02x   "),status[0],status[1]);
					printf_P(PSTR("TEF:0x%02x   DC: "),status[2]);
					for (i=3; i<15;i++) printf_P(PSTR("%02x "),status[i]);
					printf_P(PSTR("\n"));
					printf_P(PSTR("2: LOD:0x%02x%02x   "),status[24+0],status[24+1]);
					printf_P(PSTR("TEF:0x%02x   DC: "),status[24+2]);
					for (i=3; i<15;i++) printf_P(PSTR("%02x "),status[24+i]);
					printf_P(PSTR("\n\n"));
					break;
				case 'p':	//for debug only
					printf_P(PSTR("DDRA :0x%02x\nPORTA:0x%02x\nPINA :0x%02x\n\n"),DDRA,PORTA,PINA);
					printf_P(PSTR("DDRB :0x%02x\nPORTB:0x%02x\nPINB :0x%02x\n\n"),DDRB,PORTB,PINB);
					printf_P(PSTR("DDRC :0x%02x\nPORTC:0x%02x\nPINC :0x%02x\n\n"),DDRC,PORTC,PINC);
					printf_P(PSTR("DDRD :0x%02x\nPORTD:0x%02x\nPIND :0x%02x\n\n"),DDRD,PORTD,PIND);
					//printf_P(PSTR("TEF:0x%02x\nDC: ",status[2]);
					break;
				case 'e':	//for debug only
					if (!IsErr1() && !IsErr2()) {printf_P(PSTR("No error\n"));}
					else
					{
						if (IsErr1()) {printf_P(PSTR("Err 1\n"));}
						if (IsErr2()) {printf_P(PSTR("Err 2\n"));}
					}
					printf_P(PSTR("LEDStatus=0x%02x "),LEDStatus);
					printf_P(PSTR("ErrSignal_TEF=0x%02x, Err1LOD=0x%04x, Err2LOD=0x%04x\n\n"),ErrSignal_TEF,Err1LOD,Err2LOD);
					break;
				case 't':	//report temperatures
					printf_P(PSTR("Alu: %d C (%d), LED: %d C (%d)\n"),tempAlu,ADCAlu,tempLED,ADCLED);
					break;
				case 'u':	//report usage data
					h=usageCounter/3600;
					m=(usageCounter-h*3600UL)/60UL;
					s=usageCounter-h*3600UL-m*60UL;
					printf_P(PSTR("Usage: %ld s (%d:%02d:%02d)\n"),usageCounter,h,m,s);
					break;
				case '1':	//LEDs ON 10%
					printf_P(PSTR("On(LOW)\n"));
					OutputsOff();
					ReportCalibratedPowerDensities();
					SetDC(DCdata10);
					SetGSandGetStatus(GSdata,status);
					elapsedTime=0;
					OutputsOn();
					GSClkPulse();
					LEDStatus = LEDS_ON10;
					ErrSignal_TEF=0;
					Err1LOD=0;
					Err2LOD=0;
					break;
				case '2':	//LEDs ON 30%
					printf_P(PSTR("On(MEDIUM)\n"));
					OutputsOff();
					ReportCalibratedPowerDensities();
					SetDC(DCdata30);
					SetGSandGetStatus(GSdata,status);
					elapsedTime=0;
					OutputsOn();
					GSClkPulse();
					LEDStatus = LEDS_ON30;
					ErrSignal_TEF=0;
					Err1LOD=0;
					Err2LOD=0;
					break;
				case '3':	//LEDs ON 100%
					printf_P(PSTR("On(HIGH)\n"));
					OutputsOff();
					ReportCalibratedPowerDensities();
					SetDC(DCdata100);
					SetGSandGetStatus(GSdata,status);
					elapsedTime=0;
					OutputsOn();
					GSClkPulse();
					LEDStatus = LEDS_ON100;
					ErrSignal_TEF=0;
					Err1LOD=0;
					Err2LOD=0;
					break;
				case '0':	//LEDs OFF
					printf_P(PSTR("Off\n"));
					OutputsOff();
					StoreUsageData(1);
					LEDStatus = LEDS_OFF;
					ErrSignal_TEF=0;
					Err1LOD=0;
					Err2LOD=0;
					mode = MODE_DEFAULT;
					break;
				case 'T':
					ParseSetTimerCommand();
					break;
				case 'D':
					ParseSetDoseCommand();
					break;
				case 'H':	//Dot Correction for HIGH level
					printf_P(PSTR("DCdata100..."));
					ParseDCdata(DCdata100);
					OutputsOff();
					SetDC(DCdata100);
					SetGSandGetStatus(GSdata,status);
					if (LEDStatus != LEDS_OFF) OutputsOn();
					GSClkPulse();
					break;
				case 'M':	//Dot Correction for MEDIUM level
					printf_P(PSTR("DCdata30..."));
					ParseDCdata(DCdata30);
					OutputsOff();
					SetDC(DCdata30);
					SetGSandGetStatus(GSdata,status);
					if (LEDStatus != LEDS_OFF) OutputsOn();
					GSClkPulse();
					break;
				case 'L':	//Dot Correction for LOW level
					printf_P(PSTR("DCdata10..."));
					ParseDCdata(DCdata10);
					OutputsOff();
					SetDC(DCdata10);
					SetGSandGetStatus(GSdata,status);
					if (LEDStatus != LEDS_OFF) OutputsOn();
					GSClkPulse();
					break;
				case 'C': //receive calibration data
					ParseCalData();
					break;
				case 'K': //receive correction factor 
					ParseSetCorrFactorCommand();
					break;
				case 's': //Save DC data to EEPROM
					printf_P(PSTR("Saving data to EEPROM\n"));
					SaveDataToEEPROM();
					break;
				case 'E': //Get All EEPROM DATA
					PrintEEPROMData();
					break;
				default:
					printf_P(PSTR("Unknown command\n"));
					break;
			}
		}
		UpdateUsage();
		CountDown();
		SelfDiagnostic();
		if (Has_X_MillisecondsPassed(200,&timeReport)) ReportStatus();
    }
}

void SelfDiagnostic()
{
	static uint32_t timeMarkTempChk=0;
	uint8_t tempStatusChange=0;

	if (!ErrSignal_TEF)
	{
		if (IsErr1() || IsErr2()) 
		{
			SetGSandGetStatus(GSdata,status);
			SetGSandGetStatus(GSdata,status);	
			Err1LOD = ((uint16_t)status[0]<<8) | ((uint16_t)status[1] & 0xff);
			Err2LOD = ((uint16_t)status[24+0]<<8) | ((uint16_t)status[24+1] & 0xff);
			ErrSignal_TEF = ((status[2]>>7) & 0x01) | ((status[24+2]>>6) & 0x02);
			if (IsErr1()) ErrSignal_TEF |= 0x04;
			if (IsErr2()) ErrSignal_TEF |= 0x08;
			if (!(ErrSignal_TEF & 0x03) && (Err1LOD == 0xaad5) && (Err2LOD == 0xaad5))
			{
				LEDStatus = LEDS_NO_POWER;
				ErrSignal_TEF=0;
				Err1LOD=0;
				Err2LOD=0;
			}
			else LEDStatus=LEDS_ERROR;
			
			OutputsOff();
		}
	}
	if (Has_X_MillisecondsPassed(1000,&timeMarkTempChk))
	{
		ReadNTCtemperature();
		if (tempAlu > 70) {ErrSignal_TEF |= 0x40; tempStatusChange=1;}
		if (tempAlu < 50) {ErrSignal_TEF &=~0x40; tempStatusChange=1;}
		if (tempLED > 70) {ErrSignal_TEF |= 0x80; tempStatusChange=1;}
		if (tempLED < 50) {ErrSignal_TEF &=~0x80; tempStatusChange=1;}
		
		if ( tempStatusChange && (ErrSignal_TEF & 0xC0) )
		{
			if (LEDStatus == LEDS_ON10)  {LEDStatus = LEDS_ON10_OVERTEMP;  OutputsOff();}
			if (LEDStatus == LEDS_ON30)  {LEDStatus = LEDS_ON30_OVERTEMP;  OutputsOff();}
			if (LEDStatus == LEDS_ON100) {LEDStatus = LEDS_ON100_OVERTEMP; OutputsOff();}
		}
		else if ( tempStatusChange && !(ErrSignal_TEF & 0xC0) )
		{
			if (LEDStatus == LEDS_ON10_OVERTEMP)  {LEDStatus = LEDS_ON10;  OutputsOn();}
			if (LEDStatus == LEDS_ON30_OVERTEMP)  {LEDStatus = LEDS_ON30;  OutputsOn();}
			if (LEDStatus == LEDS_ON100_OVERTEMP) {LEDStatus = LEDS_ON100; OutputsOn();}
		}
	}
}

void CountDown()
{
	static uint32_t timeMark;

	if (Has_X_MillisecondsPassed(1000,&timeMark))
	{
		switch (mode)
		{
			case MODE_DEFAULT: return;
			case MODE_TIMER:
				if ( (LEDStatus == LEDS_ON10) || (LEDStatus == LEDS_ON30) || (LEDStatus == LEDS_ON100) )
				{
					timer--;
					if (timer<=0) 
					{
						mode = MODE_DEFAULT;
						printf_P(PSTR("Timer done - LEDs off.\n"));
						OutputsOff();
						StoreUsageData(1);
						LEDStatus = LEDS_OFF;
						ErrSignal_TEF=0;
						Err1LOD=0;
						Err2LOD=0;
					}
				}
				break;
			case MODE_DOSE:
				switch (LEDStatus)
				{
					case LEDS_ON10: dose -= CalData[0]*K / 1000.0; break;
					case LEDS_ON30: dose -= CalData[1]*K / 1000.0; break;
					case LEDS_ON100: dose -= CalData[2]*K / 1000.0; break;
					default: break;
				}
				if (dose<=0.0)
				{
					mode = MODE_DEFAULT;
					printf_P(PSTR("Dose done - LEDs off.\n"));
					OutputsOff();
					StoreUsageData(1);
					LEDStatus = LEDS_OFF;
					ErrSignal_TEF=0;
					Err1LOD=0;
					Err2LOD=0;
				}
				break;
			default: break;
		}
	}
}

void ParseSetTimerCommand()
{
	char c;

	printf_P(PSTR("Set timer:"));
	timer=0;
	do
	{
		while (!UART0_DataReady());
		c = UART0_GetByte();
		if ((c >= '0') && (c <= '9'))
		{
			timer *= 10;
			timer += c - '0';
		}
	} while (c != '\n');
	printf_P(PSTR(" %ld s.\n"),timer);
	mode = MODE_TIMER;
}

void ParseSetDoseCommand()
{
	char c;
	float divider;
	uint8_t decimalPoint;
		
	printf_P(PSTR("Set dose:"));
	decimalPoint=0;
	divider=1;
	dose=0;
	do
	{
		while (!UART0_DataReady());
		c = UART0_GetByte();
		if ((c == '.') || (c == ',')) decimalPoint = 1;
		if (!decimalPoint)
		{
			if ((c >= '0') && (c <= '9'))
			{
				dose *= 10.0;
				dose += c - '0';
			}
		}
		else
		{
			if ((c >= '0') && (c <= '9'))
			{
				divider *= 10.0;
				dose += (float)(c - '0') / divider;
			}
		}
				
	} while (c != '\n');
	printf_P(PSTR(" %.3f J/m2.\n"),dose);
	mode = MODE_DOSE;
}

void ParseSetCorrFactorCommand()
{
	char c;
	float divider;
	uint8_t decimalPoint;
	
	printf_P(PSTR("Set corr. factor:"));
	decimalPoint=0;
	divider=1;
	K=0;
	do
	{
		while (!UART0_DataReady());
		c = UART0_GetByte();
		if ((c == '.') || (c == ',')) decimalPoint = 1;
		if (!decimalPoint)
		{
			if ((c >= '0') && (c <= '9'))
			{
				K *= 10.0;
				K += c - '0';
			}
		}
		else
		{
			if ((c >= '0') && (c <= '9'))
			{
				divider *= 10.0;
				K += (float)(c - '0') / divider;
			}
		}
		
	} while (c != '\n');
	printf_P(PSTR(" %.6f \n"),K);
}

void ParseDCdata(uint8_t* data)
{
	int i;
	char c;
	int val;
	uint8_t last=0;
	
	for (i=0; i<16*TLC59401_COUNT; i++) data[i]=0;	//Clear all
	for (i=0; i<18; i++)	//get all 18 bytes
	{
		val=0;
		do
		{
			while (!UART0_DataReady());
			c = UART0_GetByte();
			if (c == '\n') {last = 1; break;}
			if ((c >= '0') && (c <= '9'))
			{
				val *= 10;
				val += c - '0';
			}
		} while (c != ' ');
		if (val > 63) val=63;
		if (val < 0) val=0;
		switch (i)
		{
			case 0: data[6] = val; break;
			case 1: data[4] = val; break;
			case 2: data[2] = val; break;
			case 3: data[31] = val; break;
			case 4: data[29] = val; break;
			case 5: data[27] = val; break;
			case 6: data[7] = val; break;
			case 7: data[0] = val; break;
			case 8: data[15] = val; break;
			case 9: data[16] = val; break;
			case 10: data[18] = val; break;
			case 11: data[25] = val; break;
			case 12: data[9] = val; break;
			case 13: data[11] = val; break;
			case 14: data[13] = val; break;
			case 15: data[20] = val; break;
			case 16: data[22] = val; break;
			case 17: data[23] = val; break;
			default: break;
		}
		if (last) break;
	}
	printf_P(PSTR("Thank you.\n"));
}

void PrintEEPROMData()
{
	int i,j;
	uint8_t *data;
	uint8_t val;
	
	for (j=0; j<3; j++)
	{
		switch (j)
		{
			case 0: 
				printf_P(PSTR("DC_HIGH:"));
				data = DCdata100;
				break;
			case 1:
				printf_P(PSTR("DC_MEDIUM:"));
				data = DCdata30;
				break;
			default:
				printf_P(PSTR("DC_LOW:"));
				data = DCdata10;
				break;
		}
		for (i=0; i<18; i++)
		{
			switch (i)
			{
				case 0: val = data[6]; break;
				case 1: val = data[4]; break;
				case 2: val = data[2]; break;
				case 3: val = data[31]; break;
				case 4: val = data[29]; break;
				case 5: val = data[27]; break;
				case 6: val = data[7]; break;
				case 7: val = data[0]; break;
				case 8: val = data[15]; break;
				case 9: val = data[16]; break;
				case 10: val = data[18]; break;
				case 11: val = data[25]; break;
				case 12: val = data[9]; break;
				case 13: val = data[11]; break;
				case 14: val = data[13]; break;
				case 15: val = data[20]; break;
				case 16: val = data[22]; break;
				case 17: val = data[23]; break;
				default: val = 255; break;
			}
			printf_P(PSTR("%d,"),val);
		}
		printf_P(PSTR(" "));
		_delay_ms(10);
	}
	printf_P(PSTR(" PD_HIGH: %f, "),CalData[2]);
	_delay_ms(5);
	printf_P(PSTR(" PD_MEDIUM: %f, "),CalData[1]);
	_delay_ms(5);
	printf_P(PSTR(" PD_LOW: %f [mW/m2](CIE), "),CalData[0]);
	_delay_ms(5);
	printf_P(PSTR("K: %f."),K);
}

void ParseCalData()
{
	int i;
	char c;
	float val;
	float divider;
	uint8_t decimalPoint;
	uint8_t last=0;
	
	printf_P(PSTR("Calibration data..."));
	for (i=0; i<3; i++)
	{
		decimalPoint=0;
		divider=1;
		val=0;
		do
		{
			while (!UART0_DataReady());
			c = UART0_GetByte();
			if (c == '\n') {last = 1; break;}
			if ((c == '.') || (c == ',')) decimalPoint = 1;
			if (!decimalPoint)
			{
				if ((c >= '0') && (c <= '9'))
				{
					val *= 10.0;
					val += c - '0';
				}				
			}
			else
			{
				if ((c >= '0') && (c <= '9'))
				{
					divider *= 10.0;
					val += (float)(c - '0') / divider;
				}				
			}
			
		} while (c != ' ');
		CalData[i]=val;
		if (last) break;
	}
	printf_P(PSTR("Thank you.\n"));
}

void ReportStatus()
{
	char statusMsg[13];
	char val;

	statusMsg[0] = 0xFF;			//Status message mark
	statusMsg[1] = IsUVB() != 0;	//UV light type
	statusMsg[2] = (mode<<4) | (LEDStatus & 0x0f);		//Power status (High, Medium, Low, Off)
	statusMsg[3]=elapsedTime>>24;			//Elapsed time of illumination
	statusMsg[4]=(elapsedTime>>16) & 0xFF;	//Elapsed time of illumination
	statusMsg[5]=(elapsedTime>>8) & 0xFF;	//Elapsed time of illumination
	statusMsg[6]=elapsedTime & 0xFF;		//Elapsed time of illumination
	if (tempLED < 0) val=128;
	else if (tempLED > 127) val=127;
	else val=tempLED;
	statusMsg[7] = val;				//temperature LED
	if (tempAlu < 0) val=128;
	else if (tempAlu > 127) val=127;
	else val=tempAlu;
	statusMsg[8] = val;				//temperature Alu
	if (mode == MODE_TIMER)
	{
		statusMsg[9]=timer>>24;				
		statusMsg[10]=(timer>>16) & 0xFF;	
		statusMsg[11]=(timer>>8) & 0xFF;	
		statusMsg[12]=timer & 0xFF;		
	}
	else if (mode == MODE_DOSE)
	{
		statusMsg[9]=  (*(uint32_t *)&dose)>>24;			
		statusMsg[10]=((*(uint32_t *)&dose)>>16) & 0xFF;	
		statusMsg[11]=((*(uint32_t *)&dose)>>8) & 0xFF;	
		statusMsg[12]= (*(uint32_t *)&dose) & 0xFF;		
	}
	else
	{
		statusMsg[9]=0;
		statusMsg[10]=0;
		statusMsg[11]=0;
		statusMsg[12]=0;
	}
	
	if (TB_SIZE0 - UART0_numTxBytes() > 13)
	{
		UART0_SendBytes(statusMsg,13);
	}	
}

void ReportCalibratedPowerDensities()
{
	char statusMsg[17];
	int i;
	uint32_t *ptrUI_CalData = (uint32_t *)CalData;

	statusMsg[0]=0xFE;	//Calibrated output power message mark
	for (i=0; i<3; i++)
	{
		statusMsg[4*i+1] = ptrUI_CalData[i]>>24;
		statusMsg[4*i+2] = ptrUI_CalData[i]>>16;
		statusMsg[4*i+3] = ptrUI_CalData[i]>>8;
		statusMsg[4*i+4] = ptrUI_CalData[i];
	}
	statusMsg[4*3+1] = (*((uint32_t*)&K))>>24;
	statusMsg[4*3+2] = (*((uint32_t*)&K))>>16;
	statusMsg[4*3+3] = (*((uint32_t*)&K))>>8;
	statusMsg[4*3+4] = *((uint32_t*)&K);
	while (TB_SIZE0 - UART0_numTxBytes() < 17) {}	//wait until enough space in the transmit buffer
	UART0_SendBytes(statusMsg,17);
}

void ValidateCommandAndResetUsageCounter()
{
	int i;
	char pass[]="esetU!";
	char c,validated=1;
	
	for (i=0; pass[i]; i++)
	{
		while (!UART0_DataReady()) {}	//wait for next char
		c= UART0_PreviewRxByte(0);	//peek inside the Rx buffer
		if (c == pass[i])	//if the next byte is correct, continue, else abort, leaving the byte in the buffer so as not to give the user a clue that something was going on.
		{
			UART0_GetByte();
		}
		else
		{
			validated=0;
			break;
		}	
	}
	if (validated)
	{
		InvalidateBackedupUsageData();
		usageCounter = 0;
	}
	printf_P(PSTR("confirm..."));
}

void Init_IO()
{
	PORTA=0xFF;
	PORTB=0xFF;
	PORTC=0xFF;
	PORTD=0xFF;
	//1-out, 0-in
	DDRA=0x00;
	DDRB=0x00;
	DDRC=0x00;
	DDRD=0x00;
}